#include <amxmodx>
#include <engine>
#include <fakemeta> 
#include <fakemeta_util> 
#include <fun>
#include <cstrike>
#include <amxmisc>
#include <hamsandwich>

#define PLUGIN "SnowWars beta"
#define VERSION "5.3"
#define AUTHOR "HoLLyWooD"

// Defines
#define SW_CUSTOMIZATION_FILE "snow_wars.ini"
#define STEP_DELAY 0.5
#define MAX_CSDM_SPAWNS 128

// CS Player PData Offsets (win32)
const PDATA_SAFE = 2;
const OFFSET_CSTEAMS = 114;
const OFFSET_MODELINDEX = 491;

// Linux diff's
const OFFSET_LINUX = 5 // offsets 5 higher in Linux builds

// Customization sections
enum
{
	SECTION_NONE = 0,
	SECTION_SKY,
	SECTION_MODELS,
	SECTION_ENT_MDLS,
	SECTION_ACCESS_FLAGS,
	SECTION_REMOVE_ENTS,
	SECTION_CUSTOM_SOUNDS,
	SECTION_CUSTOM_SETTINGS
}

// Access flags
enum
{
	ACCESS_ADMIN_MENU=0,
	MAX_ACCESS_FLAGS
}

// CS Teams
enum
{
	FM_CS_TEAM_UNASSIGNED = 0,
	FM_CS_TEAM_T,
	FM_CS_TEAM_CT,
	FM_CS_TEAM_SPECTATOR
}

// TASK enums
enum(+=100)
{
	TASK_MODEL = 100,
	TASK_RESPAWN,
	TASK_UNCHILL,
	TASK_GOD,
	TASK_FORCE_TEAM
}

// arrays
new g_fog_density[64], g_fog_color[64], g_fog_enable;
new Array:g_sky_names, Array:g_new_ents, Array:g_objective_ents;
new Array:model_ct, Array:model_t, Array:model_dm, Array:model_ent;
new Array:g_step_sound, Array:g_hit_sound, Array:g_pain_sound, Array:g_chill_sound, Array:g_unchill_sound;
new Array:g_winred_sound, Array:g_winblue_sound, Array:g_windraw_sound;
new Array:g_blocksound;

// constants
new g_sky_enable, g_access_flag[MAX_ACCESS_FLAGS], g_endround;
new g_fwSpawn;
new bool:g_fullsave = false, bool:g_IsChilled[33], bool:g_IsGod[33], bool:g_isconnected[33];
new Float:g_fNextStep[33], Float:g_maxspeed[33], Float:g_ChillySpeed[33], g_szCounter[33];
new g_spawnCount, g_spawnCount2;
new Float:g_spawns[MAX_CSDM_SPAWNS][3], Float:g_spawns2[MAX_CSDM_SPAWNS][3];
new model_nade_world[64], model_nade_view[64], model_nade_player[64], model_knife_view[64], model_knife_player[64], g_modname[32];

const HIDE_FLAGS = (1<<4)|(1<<5)|(1<<6);
const FFADE_IN = 0x0000;
const BREAK_GLASS = 0x01;

new pcvar_dmg,pcvar_crosshair, pcvar_gravity, pcvar_velocity, pcvar_on; 
new pcvar_dm, pcvar_dm_time, pcvar_chill_duration, pcvar_chill_speed;
new pcvar_protect, pcvar_auto_join, pcvar_random_spawn, pcvar_random_models, pcvar_ff;
new g_weapon, g_death, g_msgScreenFade, gmsgScoreInfo, g_msgSayText;
new g_glass, g_spray, g_drop, g_trail, g_maxplayers;

/******************************/
/* plugin initalization BEGIN */
/******************************/

public plugin_precache(){
	// creating arrays
	g_sky_names = 		ArrayCreate(32,1);
	model_ct = 		ArrayCreate(32,1);
	model_t = 		ArrayCreate(32,1);
	model_dm = 		ArrayCreate(32,1);
	model_ent = 		ArrayCreate(32,1);
	
	g_new_ents = 		ArrayCreate(1,1);
	g_objective_ents = 	ArrayCreate(32,1);
	g_blocksound =		ArrayCreate(64,1);
	
	g_step_sound = 		ArrayCreate(64,1);
	g_hit_sound =		ArrayCreate(64,1);
	g_pain_sound =		ArrayCreate(64,1);
	g_chill_sound =		ArrayCreate(64,1);
	g_unchill_sound =	ArrayCreate(64,1);
	g_winblue_sound =	ArrayCreate(64,1);
	g_winred_sound =	ArrayCreate(64,1);
	g_windraw_sound =	ArrayCreate(64,1);
	
	// load file customization
	load_settings_from_file();
	
	new i, buffer[128];
	
	// Custom player models
	for (i = 0; i < ArraySize(model_ct); i++){
		ArrayGetString(model_ct, i, buffer, charsmax(buffer));
		format(buffer, charsmax(buffer), "models/player/%s/%s.mdl", buffer, buffer);
		engfunc(EngFunc_PrecacheModel, buffer);
		copy(buffer[strlen(buffer)-4], charsmax(buffer) - (strlen(buffer)-4), "T.mdl");
		if (file_exists(buffer)) engfunc(EngFunc_PrecacheModel, buffer);
	}
	for (i = 0; i < ArraySize(model_t); i++){
		ArrayGetString(model_t, i, buffer, charsmax(buffer));
		format(buffer, charsmax(buffer), "models/player/%s/%s.mdl", buffer, buffer);
		engfunc(EngFunc_PrecacheModel, buffer);
		copy(buffer[strlen(buffer)-4], charsmax(buffer) - (strlen(buffer)-4), "T.mdl");
		if (file_exists(buffer)) engfunc(EngFunc_PrecacheModel, buffer);
	}
	for (i = 0; i < ArraySize(model_dm); i++){
		ArrayGetString(model_dm, i, buffer, charsmax(buffer));
		format(buffer, charsmax(buffer), "models/player/%s/%s.mdl", buffer, buffer);
		engfunc(EngFunc_PrecacheModel, buffer);
		copy(buffer[strlen(buffer)-4], charsmax(buffer) - (strlen(buffer)-4), "T.mdl");
		if (file_exists(buffer)) engfunc(EngFunc_PrecacheModel, buffer);
	}
	for (i = 0; i < ArraySize(model_ent); i++){
		ArrayGetString(model_ent, i, buffer, charsmax(buffer));
		format(buffer, charsmax(buffer), "models/sw/%s.mdl", buffer, buffer);
		engfunc(EngFunc_PrecacheModel, buffer);
		copy(buffer[strlen(buffer)-4], charsmax(buffer) - (strlen(buffer)-4), "T.mdl");
		if (file_exists(buffer)) engfunc(EngFunc_PrecacheModel, buffer);
	}
	
	// Custom sounds
	for (i = 0; i < ArraySize(g_step_sound); i++){
		ArrayGetString(g_step_sound, i, buffer, charsmax(buffer));
		engfunc(EngFunc_PrecacheSound, buffer);
	}
	for (i = 0; i < ArraySize(g_hit_sound); i++){
		ArrayGetString(g_hit_sound, i, buffer, charsmax(buffer));
		engfunc(EngFunc_PrecacheSound, buffer);
	}
	for (i = 0; i < ArraySize(g_pain_sound); i++){
		ArrayGetString(g_pain_sound, i, buffer, charsmax(buffer));
		engfunc(EngFunc_PrecacheSound, buffer);
	}
	for (i = 0; i < ArraySize(g_chill_sound); i++){
		ArrayGetString(g_chill_sound, i, buffer, charsmax(buffer));
		engfunc(EngFunc_PrecacheSound, buffer);
	}
	for (i = 0; i < ArraySize(g_unchill_sound); i++){
		ArrayGetString(g_unchill_sound, i, buffer, charsmax(buffer));
		engfunc(EngFunc_PrecacheSound, buffer);
	}
	for (i = 0; i < ArraySize(g_winblue_sound); i++){
		ArrayGetString(g_winblue_sound, i, buffer, charsmax(buffer));
		engfunc(EngFunc_PrecacheSound, buffer);
	}
	for (i = 0; i < ArraySize(g_winred_sound); i++){
		ArrayGetString(g_winred_sound, i, buffer, charsmax(buffer));
		engfunc(EngFunc_PrecacheSound, buffer);
	}
	for (i = 0; i < ArraySize(g_windraw_sound); i++){
		ArrayGetString(g_windraw_sound, i, buffer, charsmax(buffer));
		engfunc(EngFunc_PrecacheSound, buffer);
	}
	
	g_maxplayers = get_maxplayers();
	
	// Precache models for snowball
	engfunc(EngFunc_PrecacheModel,model_nade_world);
	engfunc(EngFunc_PrecacheModel,model_nade_view);
	engfunc(EngFunc_PrecacheModel,model_nade_player);
	engfunc(EngFunc_PrecacheModel,model_knife_view);
	engfunc(EngFunc_PrecacheModel,model_knife_player);
	
	// Preacche standart sprites for snowball
	g_drop = engfunc(EngFunc_PrecacheModel,"sprites/blood.spr");
	g_spray = engfunc(EngFunc_PrecacheModel,"sprites/bloodspray.spr");
	g_trail = engfunc(EngFunc_PrecacheModel,"sprites/smoke.spr");
	g_glass = engfunc(EngFunc_PrecacheModel,"models/glassgibs.mdl");
	
	// Create snow weather
	engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "env_snow"));
	
	if(g_fog_enable){
		new ent = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "env_fog"));
		if (pev_valid(ent)){
			fm_set_kvd(ent, "density", g_fog_density, "env_fog");
			fm_set_kvd(ent, "rendercolor", g_fog_color, "env_fog");
		}
	}
	// Plant custom entities
	load_ent_spawns();
	
	//Prevent some etnities form spawning
	g_fwSpawn = register_forward(FM_Spawn,"fw_SpawnEntity");
}

public plugin_init() {
	register_plugin(PLUGIN, VERSION, AUTHOR);
	
	// Dictionary
	register_dictionary("snowwars.txt");
	
	// Events
	register_event("CurWeapon","CurWeapon","be");
	register_event("ResetHUD","ResetHUD","abe");
	register_logevent("logevent_round_end",2,"1=Round_End");
	register_event("HLTV", "event_round_start", "a", "1=0", "2=0");
	
	//For version recognize and see what server is running this plugin
	register_cvar("sw_plugin",VERSION,FCVAR_SERVER | FCVAR_SPONLY)
	
	// Pcvars
	pcvar_on =		register_cvar("sw_on", "1");
	pcvar_dmg = 		register_cvar("sw_damage","50");
	pcvar_auto_join = 	register_cvar("sw_auto_join", "1");
	pcvar_random_spawn = 	register_cvar("sw_random_spawn", "1");
	pcvar_random_models = 	register_cvar("sw_random_models", "1");
	pcvar_crosshair = 	register_cvar("sw_hidehud","1");
	pcvar_protect = 	register_cvar("sw_protect_spawn","2.0");
	pcvar_gravity = 	register_cvar("sw_gravity","0.3");
	pcvar_velocity = 	register_cvar("sw_velocity","1.5");
	pcvar_dm = 		register_cvar("sw_dm","1");
	pcvar_ff = 		register_cvar("sw_ff","1");
	pcvar_dm_time = 	register_cvar("sw_dmtime","3.0");
	pcvar_chill_duration = 	register_cvar("sw_chill_duration","1.0");
	pcvar_chill_speed = 	register_cvar("sw_chill_speed","50.0");
	
	// Load config file for detect is mod enabled
	load_config();
	
	// If plagin disabled
	if(!get_pcvar_num(pcvar_on)) set_fail_state("[sw] Plugin disabled!");
	
	// Ham & Forwards
	unregister_forward(FM_Spawn,g_fwSpawn);
	RegisterHam(Ham_Spawn,"player","fw_PlayerSpawn",1)
	RegisterHam(Ham_TakeDamage, "player", "fw_TakeDamage",0);
	RegisterHam(Ham_Killed, "player", "fw_PlayerKilled",1);
	register_forward(FM_SetModel,"fw_SetModel");
	register_forward(FM_Touch,"fw_Touch");
	register_forward(FM_EmitSound, "fwdEmitSound_Pre", 0);
	register_forward(FM_GetGameDescription, "fw_GetGameDescription");
	
	// GMSG
	g_weapon = 		get_user_msgid("HideWeapon");
	g_death = 		get_user_msgid("DeathMsg");
	gmsgScoreInfo = 	get_user_msgid("ScoreInfo");
	g_msgSayText =		get_user_msgid("SayText");
	g_msgScreenFade = 	get_user_msgid("ScreenFade");
	
	//Messsages
	register_message(get_user_msgid("TextMsg"), "message_textmsg");
	register_message(get_user_msgid("SendAudio"),"message_audio");
	register_message(get_user_msgid("Scenario"), "message_scenario");
	register_message(get_user_msgid("HostagePos"), "message_hostagepos");
	register_message(get_user_msgid("ShowMenu"), "message_show_menu");
	register_message(get_user_msgid("VGUIMenu"), "message_vgui_menu");
	register_message(get_user_msgid("WeaponList"),"message_weaponlist");
	register_message(get_user_msgid("HideWeapon"), "message_HideWeapon");
	
	// Clcmds
	register_clcmd("sw_admin_menu", "admin_ent_menu", g_access_flag[ACCESS_ADMIN_MENU], "Entity control menu");
	register_clcmd("say /ent_menu", "admin_ent_menu", g_access_flag[ACCESS_ADMIN_MENU], "Entity control menu");
	
	// Collect random spawn points
	load_spawns();
	
	// Set custom sky
	if(g_sky_enable){
		static sky[32];
		ArrayGetString(g_sky_names, random_num(0, ArraySize(g_sky_names) - 1), sky, charsmax(sky));
		set_cvar_string("sv_skyname", sky);
	}
	
	// If DM off create fake hostage to force round ending
	if(!get_pcvar_num(pcvar_dm)){
		new ent = engfunc(EngFunc_CreateNamedEntity,engfunc(EngFunc_AllocString,"hostage_entity"));
		if(pev_valid(ent)){
			engfunc(EngFunc_SetOrigin, ent, Float:{8192.0 ,8192.0 ,8192.0});
			dllfunc(DLLFunc_Spawn, ent);
		}
	}
}

public load_config(){
	new cfgdir[32],file[192];
	get_configsdir(cfgdir, charsmax(cfgdir));
	formatex(file,sizeof file - 1,"%s/sw.cfg",cfgdir);
	
	if(file_exists(file))
		server_cmd("exec %s", file)
	else
		log_amx("[SW] SnowWars config file doesn't exist!")
}

public plugin_end()
	save_ent_spawns();

// Entity Spawn Forward
public fw_SpawnEntity(entity){
	// Invalid entity
	if (!pev_valid(entity)) return FMRES_IGNORED;
	
	// Get classname
	new classname[32], objective[32], size = ArraySize(g_objective_ents);
	pev(entity, pev_classname, classname, charsmax(classname));
	
	// Check whether it needs to be removed
	for (new i = 0; i < size; i++){
		ArrayGetString(g_objective_ents, i, objective, charsmax(objective));
		
		if (equal(classname, objective)){
			engfunc(EngFunc_RemoveEntity, entity);			
			return FMRES_SUPERCEDE;
		}
	}
	
	return FMRES_IGNORED;
}

public client_connect(id){
	g_isconnected[id] = true;
	
	client_cmd(id,"cl_weather 2");
	g_szCounter[id] = 0;
	set_task(1.0,"task_respawn_user",id+TASK_RESPAWN,_,_,"b");
}

public client_disconnect(id){
	g_isconnected[id] = false;
	
	if(task_exists(id+TASK_RESPAWN)) remove_task(id+TASK_RESPAWN);
}
/****************************/
/* PLUGIN INITALIZATION END */
/****************************/

/****************/
/* BEGIN EVENTS */
/****************/

public CurWeapon(id){	
	if (g_isconnected[id]){
		new clip, ammo, weapon = get_user_weapon(id,clip,ammo);

		if(weapon == CSW_HEGRENADE){
			//Set view model and player model
			set_pev(id,pev_viewmodel2,model_nade_view);
			set_pev(id,pev_weaponmodel2,model_nade_player);
		}else if (weapon == CSW_KNIFE ){
			set_pev(id,pev_viewmodel2,model_knife_view);
			set_pev(id,pev_weaponmodel2,model_knife_player);
		}
	}
}

public ResetHUD(id){
	g_IsChilled[id] = false;
	g_IsGod[id] = false;
	
	if(!is_user_alive(id)) return;
	
	if(g_szCounter[id] < 3) {
		g_szCounter[id]++;
		col_chat(id, "!g%L!y %L", id, "MOD_TAG", id, "WELCOME");
	}
	
	if(task_exists(id+TASK_RESPAWN)) remove_task(id+TASK_RESPAWN);
	
	cs_reset_user_model(id);

	if(task_exists(id+TASK_MODEL)) remove_task(id+TASK_MODEL);
	
	set_task(0.1,"task_set_user_model",id+TASK_MODEL);
	
	if(get_pcvar_num(pcvar_protect)){
		if(task_exists(id+TASK_GOD)) remove_task(id+TASK_GOD);
		g_IsGod[id] = true;
		
		//Set glow
		if(!get_pcvar_num(pcvar_ff))
			switch(fm_cs_get_user_team(id)){
				case FM_CS_TEAM_CT : fm_set_user_rendering(id,kRenderFxGlowShell,0,0,255,kRenderNormal,25);
				case FM_CS_TEAM_T : fm_set_user_rendering(id,kRenderFxGlowShell,255,0,0,kRenderNormal,25);
			}
		else
			fm_set_user_rendering(id,kRenderFxGlowShell,random(255),random(255),random(255),kRenderNormal,25)
		
		set_task(get_pcvar_float(pcvar_protect),"task_set_user_god",id+TASK_GOD);
	}
	
	auto_help(id);
	cs_set_user_money(id,0);
}

public logevent_round_end(){
	// Prevent this from getting called twice when restarting (bugfix)
	static Float:last, TempText[128];
	if (get_gametime() - last < 0.5) return;
	last = get_gametime();
	
	g_endround = true;
	
	// Show HUD notice, play win sound
	if (!sw_GetBlue()){
		//Red team wins
		set_hudmessage(200, 0, 0, -1.0, -1.0, 0, 0.0, 3.0, 2.0, 1.0, -1)
		show_hudmessage(0, "%L %L", LANG_PLAYER, "MOD_TAG", LANG_PLAYER, "WIN_RED");
		ArrayGetString(g_winred_sound, random_num(0, ArraySize(g_winred_sound)-1), TempText, charsmax(TempText));
	}else if (!sw_GetRed()){
		//Blue team wins
		set_hudmessage(0, 0, 200, -1.0, -1.0, 0, 0.0, 3.0, 2.0, 1.0, -1)
		show_hudmessage(0, "%L %L", LANG_PLAYER, "MOD_TAG", LANG_PLAYER, "WIN_BLUE");
		ArrayGetString(g_winblue_sound, random_num(0, ArraySize(g_winblue_sound)-1), TempText, charsmax(TempText));
	}else{
		// No one wins
		set_hudmessage(0, 200, 0, -1.0, -1.0, 0, 0.0, 3.0, 2.0, 1.0, -1)
		show_hudmessage(0, "%L %L", LANG_PLAYER, "MOD_TAG", LANG_PLAYER, "WIN_DRAW");
		ArrayGetString(g_windraw_sound, random_num(0, ArraySize(g_windraw_sound)-1), TempText, charsmax(TempText));
	}
	
	client_cmd(0, "spk ^"%s^"", TempText)
}

public event_round_start()
	g_endround = false;

/**************/
/* END EVENTS */
/**************/

/*************************/
/* FORWARDS & HAMS BEGIN */
/*************************/

public fw_PlayerSpawn(id){
	if(!g_isconnected[id])
		return;
		
	if(get_pcvar_num(pcvar_random_spawn)) do_random_spawn(id);
	
	//sw_money(id);
	message_begin(MSG_ONE, g_weapon, _, id);
	write_byte( ( get_pcvar_num(pcvar_crosshair) ) ? HIDE_FLAGS : 0);
	message_end()
}

public fw_Touch(ent,id){
	if(!pev_valid(ent))
		return FMRES_IGNORED;
		
	new classname[20],classname2[20],Float:origin[3], buffer[64], owner = pev(ent,pev_owner);
	
	pev(ent,pev_origin,origin)
	pev(id,pev_classname,classname2,charsmax(classname2))
	pev(ent,pev_classname,classname,charsmax(classname))
	
	if(equali(classname,"grenade") && equali(classname2,"player")){
		if(is_user_alive(id) && !g_IsGod[id]){
			if(cs_get_user_team(id) == cs_get_user_team(owner) && get_pcvar_num(pcvar_ff) || cs_get_user_team(id) != cs_get_user_team(owner))
				if(get_user_health(id) > get_pcvar_num(pcvar_dmg)){
					set_user_health(id, get_user_health(id) - get_pcvar_num(pcvar_dmg))
				
					static Float:ent_origin, Float:id_origin[3];
					ent_origin = origin[2];
					pev(id, pev_origin, id_origin);
					
					if( abs(floatround( ent_origin - id_origin[2])) > 15 && !g_IsChilled[id]){
						ArrayGetString(g_chill_sound, random_num(0, ArraySize(g_chill_sound) - 1), buffer, charsmax(buffer));
						engfunc(EngFunc_EmitSound,id,CHAN_AUTO,buffer,1.0,ATTN_NORM,0,PITCH_NORM)
						sw_ChillPlayer(id);
						if(task_exists(id+TASK_UNCHILL)) remove_task(id+TASK_UNCHILL);
						set_task(get_pcvar_float(pcvar_chill_duration),"task_user_unchill",id+TASK_UNCHILL);
					}else{
						ArrayGetString(g_pain_sound, random_num(0, ArraySize(g_pain_sound) - 1), buffer, charsmax(buffer));
						engfunc(EngFunc_EmitSound,id,CHAN_AUTO,buffer,1.0,ATTN_NORM,0,PITCH_NORM)
					}

					
				}else if(get_user_health(id) <= get_pcvar_float(pcvar_dmg))
					UTIL_Kill(owner,id,"snowball");	
		}
	}
	
	
	if(equali(classname,"grenade")){
		sw_effect(origin);
		ArrayGetString(g_hit_sound, random_num(0, ArraySize(g_hit_sound) - 1), buffer, charsmax(buffer));
		emit_sound(ent, CHAN_BODY, buffer, VOL_NORM, ATTN_STATIC, 0, PITCH_NORM);
		set_pev(ent, pev_flags, pev(ent, pev_flags) | FL_KILLME);
	}
	
	return FMRES_IGNORED
}

public fw_SetModel(ent,const model[]){
	if(!pev_valid(ent))
		return FMRES_IGNORED
	
	if(equali(model,"models/w_hegrenade.mdl")){
		new Float:velocity[3];
		new owner = pev(ent,pev_owner);
		
		engfunc(EngFunc_SetModel,ent,model_nade_world);
		
		if(g_isconnected[owner])
			cs_set_user_bpammo(owner, CSW_HEGRENADE, 99);
		
		set_pev(ent, pev_dmgtime, get_gametime() + 9999.0);
		set_pev(ent,pev_gravity,get_pcvar_float(pcvar_gravity));
		pev(ent, pev_velocity, velocity);
		
		velocity[0] *= get_pcvar_float(pcvar_velocity);
		velocity[1] *= get_pcvar_float(pcvar_velocity);
		velocity[2] *= get_pcvar_float(pcvar_velocity);
		
		set_pev(ent, pev_velocity,velocity);
		return FMRES_SUPERCEDE;
	}
	return FMRES_IGNORED;
}

public fw_PlayerKilled(id, attacker, shouldgib){
	if(!task_exists(id+TASK_RESPAWN) && get_pcvar_num(pcvar_dm))
		set_task(get_pcvar_float(pcvar_dm_time),"task_respawn_user",id+TASK_RESPAWN,_,_,"b");
}

public fw_TakeDamage(victim, inflictor, attacker, Float:damage, damage_type)
{
	// Non-player damage or self damage
	if (victim == attacker || !is_user_connected(attacker))
		return HAM_IGNORED
		
	return HAM_SUPERCEDE
}

public fwdEmitSound_Pre( plr, channel, const sound[] ){
	static a, buffer[64];
	//Check if emited sound is equal to one for our list
	for(a=0; a < ArraySize(g_blocksound);a++){
		//If it's equal - block it
		ArrayGetString(g_blocksound, a, buffer, charsmax(buffer));
		if(equali(sound,buffer)) return FMRES_SUPERCEDE;
	}
	
	return FMRES_IGNORED;
}

// Forward Get Game Description
public fw_GetGameDescription(){
	// Return the mod name so it can be easily identified
	forward_return(FMV_STRING, g_modname);
	
	return FMRES_SUPERCEDE;
}

/***********************/
/* FORWARDS & HAMS END */
/***********************/

/*****************************/
/* AUXILIARY FUNCTIONS BEGIN */
/*****************************/
public check_respawn(id){
	if(!is_user_alive(id) && get_pcvar_num(pcvar_dm) && !g_endround){
		remove_task(id + TASK_RESPAWN);
		set_task(get_pcvar_float(pcvar_dm_time),"task_respawn_user",id + TASK_RESPAWN);
	}
	
	return PLUGIN_CONTINUE;
}

public UTIL_Kill(attacker,id,weapon[]){
	set_user_frags(attacker,get_user_frags(attacker) +1);

	set_msg_block(g_death , BLOCK_SET)
	user_kill(id,1)
	set_msg_block(g_death, BLOCK_NOT)
	
	message_begin( MSG_ALL, g_death,{0,0,0},0) 
	write_byte(attacker) 
	write_byte(id) 
	write_byte(0) 
	write_string(weapon) 
	message_end() 

	message_begin(MSG_ALL,gmsgScoreInfo) 
	write_byte(attacker) 
	write_short(get_user_frags(attacker)) 
	write_short(get_user_deaths(attacker)) 
	write_short(0) 
	write_short(get_user_team(attacker)) 
	message_end() 
	
	message_begin(MSG_ALL,gmsgScoreInfo) 
	write_byte(id) 
	write_short(get_user_frags(id)) 
	write_short(get_user_deaths(id)) 
	write_short(0) 
	write_short(get_user_team(id)) 
	message_end()
}

public sw_effect(Float:fOrigin[3]){
	new origin[3]
	FVecIVec(fOrigin,origin)
	
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte(TE_BLOODSPRITE)
	write_coord(origin[0])
	write_coord(origin[1])
	write_coord(origin[2])
	write_short(g_spray)
	write_short(g_drop)
	write_byte(255)
	write_byte(15)
	message_end()
}

public sw_ChillPlayer(id){
	//Set glow
	fm_set_user_rendering(id,kRenderFxGlowShell,0,206,209,kRenderNormal,25)
	
	//Set chill state
	g_IsChilled[id] = true
	
	//Retrieve player old maxspeed
	pev(id,pev_maxspeed,g_maxspeed[id])
	
	//Calculate his new maxspeed
	g_ChillySpeed[id] = g_maxspeed[id] * get_pcvar_float(pcvar_chill_speed) / 100.0
	
	//Set his new maxspeed
	set_pev(id,pev_maxspeed,g_ChillySpeed[id])
	
	//Add blue fade on players screen
	message_begin(MSG_ONE,g_msgScreenFade,_,id)
	write_short(floatround(4096.0 * get_pcvar_float(pcvar_chill_duration))) // duration
	write_short(floatround(3072.0 * get_pcvar_float(pcvar_chill_duration))) // hold time
	write_short(FFADE_IN) // flags
	write_byte(0) // red
	write_byte(206) // green
	write_byte(209) // blue
	write_byte(100) // alpha
	message_end()
}

public sw_UnChill(id,Float:fOrigin[3]){	
	//Make some variables
	new origin[3]
	
	//Change origin from float to integer
	FVecIVec(fOrigin,origin)
	
	//Delete glow
	fm_set_user_rendering(id,kRenderFxGlowShell,0,0,0,kRenderNormal,25)
	
	//Restore his maxspeed
	set_pev(id,pev_maxspeed,g_maxspeed[id])
	
	//Set chill state
	g_IsChilled[id] = false
	
	// clear tint
	message_begin(MSG_ONE,g_msgScreenFade,_,id)
	write_short(0) // duration
	write_short(0) // hold time
	write_short(FFADE_IN) // flags
	write_byte(0) // red
	write_byte(0) // green
	write_byte(0) // blue
	write_byte(255)// alpha
	message_end()
	
	//Make glass effect
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte(TE_BREAKMODEL)
	write_coord(origin[0]) // x
	write_coord(origin[1]) // y
	write_coord(origin[2] + 24) // z
	write_coord(16) // size x
	write_coord(16) // size y
	write_coord(16) // size z
	write_coord(random_num(-50,50)) // velocity x
	write_coord(random_num(-50,50)) // velocity y
	write_coord(25) // velocity z
	write_byte(10) // random velocity
	write_short(g_glass) // model
	write_byte(10) // count
	write_byte(25) // life
	write_byte(BREAK_GLASS) // flags
	message_end()
	
	//Emit sound
	static buffer[64];
	ArrayGetString(g_unchill_sound, random_num(0, ArraySize(g_unchill_sound)-1), buffer, charsmax(buffer));
	engfunc(EngFunc_EmitSound,id,CHAN_AUTO,buffer,1.0,ATTN_NORM,0,PITCH_NORM)
}

public client_PreThink(id){
	if(!is_user_alive(id))
		return FMRES_IGNORED;
	
	static Float:fGmTime; fGmTime = get_gametime();
	if(g_fNextStep[id] < fGmTime){
		if(fm_get_user_speed(id) && (pev(id, pev_flags) & FL_ONGROUND) && is_user_outside(id)){
			set_pev(id, pev_flTimeStepSound, 999);
			static buffer[64];
			ArrayGetString(g_step_sound, random_num(0, ArraySize(g_step_sound) - 1), buffer, charsmax(buffer));
			engfunc(EngFunc_EmitSound, id, CHAN_AUTO, buffer, 0.5, ATTN_NORM, 0, PITCH_NORM);
			g_fNextStep[id] = fGmTime + STEP_DELAY;
		}
	}	
	return FMRES_IGNORED;
}	

public auto_help(id){
		new rnd = random_num(1,10)
		if (rnd <= 3)
			set_hudmessage(0, 255, 0, -1.0, 0.70, 0, 10.0, 5.0, 0.1, 0.5, 11) 	
		if (rnd == 1)
			show_hudmessage(id, "%L",LANG_PLAYER,"HELP1")
		if (rnd == 2)
			show_hudmessage(id, "%L",LANG_PLAYER,"HELP2")
		if (rnd == 2)
			show_hudmessage(id, "%L",LANG_PLAYER,"HELP2")
}

public grenade_throw(id, gid, wid){
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(TE_BEAMFOLLOW)
	write_short(gid)
	write_short(g_trail)
	write_byte(10)
	write_byte(5)
	write_byte(0)
	write_byte(25)
	write_byte(25)
	write_byte(200)
	message_end()
}

bool:should_autojoin(id) {
	return (!get_user_team(id) && !task_exists(id+TASK_FORCE_TEAM))
}

set_force_team_join_task(id, menu_msgid) {
	static param_menu_msgid[2]
	param_menu_msgid[0] = menu_msgid
	set_task(0.1, "task_force_team_join", id+TASK_FORCE_TEAM, param_menu_msgid, sizeof param_menu_msgid)
}

// Checks if a space is vacant (credits to VEN)
stock is_hull_vacant(Float:origin[3], hull){
	engfunc(EngFunc_TraceHull, origin, origin, 0, hull, 0, 0);
	
	if (!get_tr2(0, TR_StartSolid) && !get_tr2(0, TR_AllSolid) && get_tr2(0, TR_InOpen))
		return true;
	
	return false;
}

// Place user at a random spawn
do_random_spawn(id, regularspawns = 0){
	static hull, sp_index, i
	
	// Get whether the player is crouching
	hull = (pev(id, pev_flags) & FL_DUCKING) ? HULL_HEAD : HULL_HUMAN;
	
	// Use regular spawns?
	if (!regularspawns){
		// No spawns?
		if (!g_spawnCount)
			return;
		
		// Choose random spawn to start looping at
		sp_index = random_num(0, g_spawnCount - 1);
		
		// Try to find a clear spawn
		for (i = sp_index + 1; /*no condition*/; i++){
			// Start over when we reach the end
			if (i >= g_spawnCount) i = 0
			
			// Free spawn space?
			if (is_hull_vacant(g_spawns[i], hull)){
				// Engfunc_SetOrigin is used so ent's mins and maxs get updated instantly
				engfunc(EngFunc_SetOrigin, id, g_spawns[i]);
				break;
			}
			
			// Loop completed, no free space found
			if (i == sp_index) break;
		}
	}else{
		// No spawns?
		if (!g_spawnCount2)
			return;
		
		// Choose random spawn to start looping at
		sp_index = random_num(0, g_spawnCount2 - 1)
		
		// Try to find a clear spawn
		for (i = sp_index + 1; /*no condition*/; i++){
			// Start over when we reach the end
			if (i >= g_spawnCount2) i = 0
			
			// Free spawn space?
			if (is_hull_vacant(g_spawns2[i], hull)){
				// Engfunc_SetOrigin is used so ent's mins and maxs get updated instantly
				engfunc(EngFunc_SetOrigin, id, g_spawns2[i])
				break;
			}
			
			// Loop completed, no free space found
			if (i == sp_index) break;
		}
	}
}

sw_GetBlue(){
	static iCt, id;
	iCt = 0;
	
	for (id = 1; id <= g_maxplayers; id++)
		if (g_isconnected[id])
			if(is_user_alive(id) && fm_cs_get_user_team(id) == FM_CS_TEAM_CT)
				iCt++;
	
	return iCt;
}
sw_GetRed(){
	static iT, id;
	iT = 0;
	
	for (id = 1; id <= g_maxplayers; id++)
		if (g_isconnected[id])
			if(is_user_alive(id) && fm_cs_get_user_team(id) == FM_CS_TEAM_T)
				iT++;
	
	return iT;
}

/***************************/
/* AUXILIARY FUNCTIONS END */
/***************************/

/******************/
/* MESSAGES BEGIN */
/******************/

public message_textmsg(){
	static textmsg[22]
	get_msg_arg_string(2, textmsg, sizeof textmsg - 1)
	if (equal(textmsg, "#Hostages_Not_Rescued") || equal(textmsg, "#Round_Draw") || equal(textmsg, "#Terrorists_Win") || equal(textmsg, "#CTs_Win"))
		return PLUGIN_HANDLED;
	
	if(get_msg_args() == 5){
		if(get_msg_argtype(5) == ARG_STRING){
			new value5[64]
			get_msg_arg_string(5 ,value5 ,63)
			if(equal(value5, "#Fire_in_the_hole"))
				return PLUGIN_HANDLED;
		}
	}else if(get_msg_args() == 6){
		if(get_msg_argtype(6) == ARG_STRING){
			new value6[64]
			get_msg_arg_string(6 ,value6 ,63)
			if(equal(value6 ,"#Fire_in_the_hole"))
				return PLUGIN_HANDLED;
		}
	}
	return PLUGIN_CONTINUE
}

public message_audio(){
	static sample[20]
	
	get_msg_arg_string(2, sample, sizeof sample - 1)
	
	if(equal(sample[1], "!MRAD_FIREINHOLE"))
		return PLUGIN_HANDLED
			
	if(equal(sample[7], "terwin") || equal(sample[7], "ctwin") || equal(sample[7], "rounddraw"))
		return PLUGIN_HANDLED
	
	return PLUGIN_CONTINUE
}

public message_scenario(){
	if (get_msg_args() > 1){
		static sprite[8]
		get_msg_arg_string(2, sprite, sizeof sprite - 1)
		
		if (equal(sprite, "hostage"))
			return PLUGIN_HANDLED
	}
	return PLUGIN_CONTINUE
}
	
public message_hostagepos()
	return PLUGIN_HANDLED;

public message_show_menu(msgid, dest, id) {
	if (!should_autojoin(id) && !get_pcvar_num(pcvar_auto_join) )
		return PLUGIN_CONTINUE;

	static team_select[] = "#Team_Select";
	static menu_text_code[sizeof team_select];
	get_msg_arg_string(4, menu_text_code, sizeof menu_text_code - 1);
	if (!equal(menu_text_code, team_select))
		return PLUGIN_CONTINUE;

	set_force_team_join_task(id, msgid);

	return PLUGIN_HANDLED;
}

public message_vgui_menu(msgid, dest, id) {
	if (get_msg_arg_int(1) != 2 || !should_autojoin(id) && !get_pcvar_num(pcvar_auto_join))
		return PLUGIN_CONTINUE;

	set_force_team_join_task(id, msgid);

	return PLUGIN_HANDLED;
}
	
public message_weaponlist(msg_id, msg_dest, msg_entity){
	switch(get_msg_arg_int(8)){
		case CSW_HEGRENADE: set_msg_arg_int(3,1,99);
	}
}

public message_HideWeapon()
	set_msg_arg_int(1, ARG_BYTE, get_msg_arg_int(1) | HIDE_FLAGS);

/****************/
/* MESSAGES END */
/****************/

/****************/
/* TASKS BEGIN  */
/****************/

public task_respawn_user(id){
	id -= TASK_RESPAWN
	new team;
	
	switch(get_user_team(id)){
		case CS_TEAM_CT : team = 1
		case CS_TEAM_T : team = 0
		default: team = 3
	}
	if((team == 1 || team == 0) && !is_user_alive(id))
		ExecuteHamB(Ham_CS_RoundRespawn,id)
}

public task_set_user_model(id){
	id-=TASK_MODEL;
	
	if(!is_user_alive(id)) return;
	
	new TempText[128];
	if(get_pcvar_num(pcvar_dm) && get_pcvar_num(pcvar_random_models)){
		ArrayGetString(model_dm, random_num(0, ArraySize(model_dm)-1), TempText, charsmax(TempText));
	}else
		switch(fm_cs_get_user_team(id)){
			case FM_CS_TEAM_CT: ArrayGetString(model_ct, random_num(0, ArraySize(model_ct)-1), TempText, charsmax(TempText));
			case FM_CS_TEAM_T: ArrayGetString(model_t, random_num(0, ArraySize(model_t)-1), TempText, charsmax(TempText));
		}	
	
	engfunc(EngFunc_SetClientKeyValue, id, engfunc(EngFunc_GetInfoKeyBuffer, id), "model", TempText);
	cs_set_user_model(id, TempText);
	
	strip_user_weapons(id);
	
	if(!is_user_bot(id)) give_item(id,"weapon_knife");
	give_item(id,"weapon_hegrenade");
	cs_set_user_bpammo(id, CSW_HEGRENADE, 99);
}

public task_set_user_god(id){
	id -= TASK_GOD;
	g_IsGod[id] = false;
	
	if(is_user_alive(id))
		fm_set_user_rendering(id,kRenderFxGlowShell,0,0,0,kRenderNormal,25);
}

public task_force_team_join(menu_msgid[], id) {
	id-=TASK_FORCE_TEAM
	if (get_user_team(id))	return;

	force_team_join(id, menu_msgid[0], "5", "5");
}

public task_user_unchill(id){
	id -= TASK_UNCHILL;
	
	new Float:origin[3];
	pev(id,pev_origin,origin);
	
	sw_UnChill(id,origin);
}

/*************/
/* TASKS END */
/*************/

/*********************/
/* GAME CLCMDS BEGIN */
/*********************/
	

	
/*******************/
/* GAME CLCMDS END */
/*******************/	
	
/********************/
/* GAME MENUS BEGIN */
/********************/

// Entity control - admin menu
public admin_ent_menu(id){
        if(!(get_user_flags(id) & g_access_flag[ACCESS_ADMIN_MENU])) // Check if Player is admin
		return PLUGIN_HANDLED;
		
	new TempText[100], menu;
	format(TempText, charsmax(TempText),"%L",id,"MENU_ENT_TITLE");
	menu = menu_create(TempText, "admin_ent_menu_handler");
	
	// 1. Create entity
	format(TempText, charsmax(TempText), "%L", id, "MENU_ENT_1");
	menu_additem(menu, TempText, "1", 0);
	
	// 2. Remove entity
	format(TempText, charsmax(TempText), "%L", id, "MENU_ENT_2");
	menu_additem(menu, TempText, "2", 0);
	
	// 0. Exit
	menu_setprop(menu, MPROP_EXIT, MEXIT_ALL );
	
	menu_display(id, menu, 0);
	return PLUGIN_HANDLED;
}

// Entity control - admin menu handler
public admin_ent_menu_handler(id, menu, item){
	if ( item == MENU_EXIT ){
		menu_destroy(menu);
		return PLUGIN_HANDLED;
	}
	
	new s_Data[6], s_Name[64], i_Access, i_Callback;
	menu_item_getinfo(menu, item, i_Access, s_Data, charsmax(s_Data), s_Name, charsmax(s_Name), i_Callback);
	
	switch(str_to_num(s_Data)){
		case 1:// Create entity
		{
			admin_ent_model_menu(id);
		}
		case 2:// Remove enitty
		{
			admin_ent_remove(id);
			menu_destroy(menu);
			admin_ent_menu(id);
			return PLUGIN_HANDLED;
		}
	}
	
	menu_destroy(menu);
	return PLUGIN_HANDLED;
}

// Entity control - admin select model entity
public admin_ent_model_menu(id){
	new TempText[100], menu, menu_id[3];
	format(TempText, charsmax(TempText),"%L",id,"MENU_ENT_MODEL_TITLE");
	menu = menu_create(TempText, "admin_ent_model_menu_handler");
	
	for(new i=0; i < ArraySize(model_ent); i++){
		ArrayGetString(model_ent, i, TempText, charsmax(TempText));
		num_to_str(i+1,menu_id, charsmax(menu_id));
		menu_additem(menu, TempText, menu_id, 0);
	}
	
	// 0. Exit
	menu_setprop(menu, MPROP_EXIT, MEXIT_ALL );
	
	menu_display(id, menu, 0);
}

// Entity control - admin select model entity handler
public admin_ent_model_menu_handler(id, menu, item){
	if ( item == MENU_EXIT ){
		menu_destroy(menu);
		return PLUGIN_HANDLED;
	}
	
	new s_Data[6], s_Name[64], i_Access, i_Callback, Float:origin[3], TempText[128];
	menu_item_getinfo(menu, item, i_Access, s_Data, charsmax(s_Data), s_Name, charsmax(s_Name), i_Callback);
	
	ArrayGetString(model_ent, str_to_num(s_Data)-1, TempText, charsmax(TempText));
	entity_get_vector(id,EV_VEC_origin,origin);
	spawn_ent(1, origin, TempText);
	
	menu_destroy(menu);
	admin_ent_menu(id);
	return PLUGIN_HANDLED;
}

/******************/
/* GAME MENUS END */
/******************/

/*************************/
/* WORK WITH FILES BEGIN */
/*************************/

// Load custom entity from file
public load_ent_spawns(){
	new cfgdir[32], map[64], file[128], linedata[1024], spawns[3][13], Float:origin[3], mdl[128];
	get_mapname(map, charsmax(map));
	get_configsdir(cfgdir, charsmax(cfgdir));
	format(file, charsmax(file), "%s/snow_wars/sw-%s.ini", cfgdir, map);
	
	if(!file_exists(file)) 
		return;
	
	new rfile = fopen(file, "rt");
	
	while (rfile && !feof(rfile)){
		fgets(rfile, linedata, charsmax(linedata));
		replace(linedata, charsmax(linedata), "^n", "");
		if (!linedata[0] || linedata[0] == ';' || linedata[0] == '/') continue;
		
		parse(linedata, spawns[0], 12, spawns[1], 12, spawns[2], 12, mdl, 128);
		origin[0] = floatstr(spawns[0]);
		origin[1] = floatstr(spawns[1]);
		origin[2] = floatstr(spawns[2]);
		
		trim(mdl);
		
		spawn_ent(0, origin, mdl);
	}
	
	fclose(rfile);
}

// Save custom entity into file
public save_ent_spawns(){
	new cfgdir[32], file[128], map[64], data[1024], Float:origin[3], mdl[128], ent;
	get_mapname(map, charsmax(map));
	get_configsdir(cfgdir, charsmax(cfgdir));
		
	format(file, charsmax(file), "%s/snow_wars/sw-%s.ini", cfgdir, map);
	
	if(g_fullsave){
		if(file_exists(file))
			delete_file(file);
		
		new rfile = fopen(file, "at");
		
		format(data, charsmax(data), "; This is entity spawn configuration file^n; for map: %s^n^n^n", map);
		fputs(rfile, data);
		
		while( ( ent = find_ent_by_class(ent,"xmass_ent") ) != 0 ){
			if(!pev_valid(ent)) continue;
			
			entity_get_vector(ent, EV_VEC_origin, origin);
			entity_get_string(ent, EV_SZ_model, mdl, charsmax(mdl));
			replace_all(mdl, charsmax(mdl), "models/sw/", "");
			replace_all(mdl, charsmax(mdl), ".mdl", "");
			formatex(data, charsmax(data), "%f %f %f %s^n", origin[0], origin[1], origin[2], mdl);
			fputs(rfile, data);
		}
		fclose(rfile);
		return;
	}
	
	if(!file_exists(file)){
		new rfile = fopen(file, "at");
		format(data, charsmax(data), "; This is entity spawn configuration file^n; for map: %s^n^n^n", map);
		fputs(rfile, data);
		fclose(rfile);
		return;
	}
	
	new rfile = fopen(file, "at");
	
	for(new i=0; i < ArraySize(g_new_ents); i++){
		if(ArrayGetCell(g_new_ents, i)){
			ent = ArrayGetCell(g_new_ents, i);
			if(!pev_valid(ent)) continue;
			
			entity_get_vector(ent, EV_VEC_origin, origin);
			entity_get_string(ent, EV_SZ_model, mdl, charsmax(mdl));
			replace_all(mdl, charsmax(mdl), "models/sw/", "");
			replace_all(mdl, charsmax(mdl), ".mdl", "");
			formatex(data, charsmax(data), "%f %f %f %s^n", origin[0], origin[1], origin[2], mdl);
			fputs(rfile, data);
		}
	}
	
	fclose(rfile);
}

// Loading customization settings from file
public load_settings_from_file(){
	new path[64];
	get_configsdir(path, charsmax(path));
	format(path, charsmax(path), "%s/%s", path, SW_CUSTOMIZATION_FILE);
	
	if (!file_exists(path)){
		new error[100];
		formatex(error, charsmax(error), "Cannot load customization file %s!", path);
		set_fail_state(error);
		return;
	}
	
	new linedata[1024], key[64], value[960], section;
	
	new file = fopen(path, "rt");
	
	while (file && !feof(file)){
		fgets(file, linedata, charsmax(linedata));
		replace(linedata, charsmax(linedata), "^n", "")
		if (!linedata[0] || linedata[0] == ';' || linedata[0] == '/') continue;
		
		// New section starting
		if (linedata[0] == '['){
			section++
			continue;
		}
		
		strtok(linedata, key, charsmax(key), value, charsmax(value), '=');
		trim(key);
		trim(value);
		
		switch (section){
			case SECTION_SKY:{
				if(equal(key, "SKY ENABLE"))
					g_sky_enable = str_to_num(value)
				else if (equal(key, "SKY NAMES")){
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ',')){
						trim(key);
						trim(value);
						
						ArrayPushString(g_sky_names, key);
						
						formatex(linedata, charsmax(linedata), "gfx/env/%sbk.tga", key);
						engfunc(EngFunc_PrecacheGeneric, linedata);
						formatex(linedata, charsmax(linedata), "gfx/env/%sdn.tga", key);
						engfunc(EngFunc_PrecacheGeneric, linedata);
						formatex(linedata, charsmax(linedata), "gfx/env/%sft.tga", key);
						engfunc(EngFunc_PrecacheGeneric, linedata);
						formatex(linedata, charsmax(linedata), "gfx/env/%slf.tga", key);
						engfunc(EngFunc_PrecacheGeneric, linedata);
						formatex(linedata, charsmax(linedata), "gfx/env/%srt.tga", key);
						engfunc(EngFunc_PrecacheGeneric, linedata);
						formatex(linedata, charsmax(linedata), "gfx/env/%sup.tga", key);
						engfunc(EngFunc_PrecacheGeneric, linedata);
					}
				}else if(equal(key, "FOG ENABLE"))
					g_fog_enable = str_to_num(value)
				else if (equal(key, "FOG DENSITY")){
					copy(g_fog_density, charsmax(g_fog_density), value)
				}else if(equal(key, "FOG COLOR")){
					copy(g_fog_color, charsmax(g_fog_color), value)
				}
			}
			case SECTION_MODELS: {
				if (equal(key, "CT MODELS")){
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ',')){
						trim(key);
						trim(value);
						
						ArrayPushString(model_ct, key);
					}
				}else if (equal(key, "T MODELS")){
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ',')){
						trim(key);
						trim(value);
						
						ArrayPushString(model_t, key);
					}
				}else if (equal(key, "DM MODELS")){
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ',')){
						trim(key);
						trim(value);
						
						ArrayPushString(model_dm, key);
					}
				}
			}
			case SECTION_ENT_MDLS: {
				if (equal(key, "ENT MODELS")){
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ',')){
						trim(key);
						trim(value);
						
						ArrayPushString(model_ent, key);
					}
				}
				if (equal(key, "MODEL NADE WORLD")){
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ',')){
						trim(key);
						trim(value);
						
						format(model_nade_world, charsmax(model_nade_world), key);
					}
				}
				if (equal(key, "MODEL NADE VIEW")){
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ',')){
						trim(key);
						trim(value);
						
						format(model_nade_view, charsmax(model_nade_view), key);
					}
				}
				if (equal(key, "MODEL NADE PLAYER")){
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ',')){
						trim(key);
						trim(value);
						
						format(model_nade_player, charsmax(model_nade_player), key);
					}
				}
				if (equal(key, "MODEL KNIFE VIEW")){
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ',')){
						trim(key);
						trim(value);
						
						format(model_knife_view, charsmax(model_knife_view), key);
					}
				}
				if (equal(key, "MODEL KNIFE PLAYER")){
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ',')){
						trim(key);
						trim(value);
						
						format(model_knife_player, charsmax(model_knife_player), key);
					}
				}
			}
			case SECTION_ACCESS_FLAGS: {
				if (equal(key, "ADMIN MENU"))
					g_access_flag[ACCESS_ADMIN_MENU] = read_flags(value);
			}
			case SECTION_REMOVE_ENTS:  {
				if (equal(key, "CLASSNAMES")) {
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ',')){
						trim(key);
						trim(value);
						
						ArrayPushString(g_objective_ents, key);
					}
				}else if (equal(key, "SOUND BLOCK")) {
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ',')){
						trim(key);
						trim(value);
						
						ArrayPushString(g_blocksound, key);
					}
				}
			}
			case SECTION_CUSTOM_SOUNDS:  {
				if (equal(key, "STEP SOUNDS")) {
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ',')){
						trim(key);
						trim(value);
						
						ArrayPushString(g_step_sound, key);
					}
				}else if (equal(key, "HIT SOUNDS")) {
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ',')){
						trim(key);
						trim(value);
						
						ArrayPushString(g_hit_sound, key);
					}
				}else if (equal(key, "PAIN SOUNDS")) {
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ',')){
						trim(key);
						trim(value);
						
						ArrayPushString(g_pain_sound, key);
					}
				}else if (equal(key, "CHILL SOUNDS")) {
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ',')){
						trim(key);
						trim(value);
						
						ArrayPushString(g_chill_sound, key);
					}
				}else if (equal(key, "UNCHILL SOUNDS")) {
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ',')){
						trim(key);
						trim(value);
						
						ArrayPushString(g_unchill_sound, key);
					}
				}else if (equal(key, "WIN BLUE SOUNDS")) {
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ',')){
						trim(key);
						trim(value);
						
						ArrayPushString(g_winblue_sound, key);
					}
				}else if (equal(key, "WIN RED SOUNDS")) {
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ',')){
						trim(key);
						trim(value);
						
						ArrayPushString(g_winred_sound, key);
					}
				}else if (equal(key, "WIN DRAW SOUNDS")) {
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ',')){
						trim(key);
						trim(value);
						
						ArrayPushString(g_windraw_sound, key);
					}
				}
			}
			case SECTION_CUSTOM_SETTINGS: {
				if (equal(key, "MOD NAME")){
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ',')){
						trim(key);
						trim(value);
						
						format(g_modname, charsmax(g_modname), key);
					}
				}
			}
		}
	}
	
	fclose(file);
}

/***********************/
/* WORK WITH FILES END */
/***********************/

/*********************************/
/* CUSTOM ENTITY FUNCTIONS BEGIN */
/*********************************/

public admin_ent_remove(id){
	new Float:origin[3], ent, classname[32], bool:is_ent = false;
	entity_get_vector(id, EV_VEC_origin, origin);

	while( (ent = find_ent_in_sphere(ent, origin, 100.0)) != 0 ){
		entity_get_string(ent,EV_SZ_classname,classname,charsmax(classname));
		
		if(equali(classname,"xmass_ent") && !is_ent){
			set_pev(ent, pev_flags, pev(ent, pev_flags) | FL_KILLME);
			is_ent = true;
			g_fullsave = true;
		}
	}
	
	client_print(id, print_center, "%L", id, (is_ent) ? "ADMIN_ENT_REMOVE_OK" : "ADMIN_ENT_REMOVE_NO");
}

public spawn_ent(is_new, Float:origin[3], mdl[]){
	new Float:angles[3], some_model[128];
	angles[0] = random_float(-10.0,10.0);
	angles[1] = random_float(-180.0,180.0);
	angles[2] = 0.0;
	new ent = create_entity("info_target");
	entity_set_string(ent,EV_SZ_classname,"xmass_ent");
	
	format(some_model, charsmax(some_model), "models/sw/%s.mdl", mdl);
	entity_set_model(ent,some_model);
	
	entity_set_origin(ent,origin);
	entity_set_vector(ent, EV_VEC_angles, angles);
	entity_set_int(ent, EV_INT_solid,SOLID_TRIGGER);
	entity_set_edict(ent,EV_ENT_owner,33);
	entity_set_float(ent,EV_FL_framerate,1.0);
	entity_set_int(ent,EV_INT_sequence,0);
	drop_to_floor(ent);
	
	if(is_new) ArrayPushCell(g_new_ents, ent);
	
	return PLUGIN_HANDLED;
}

/*******************************/
/* CUSTOM ENTITY FUNCTIONS END */
/*******************************/

/****************/
/* STOCKS BEGIN */
/****************/

stock col_chat(const id, const input[], any:...){
	new count = 1, players[32]
	static msg[191]
	vformat(msg, 190, input, 3)

	replace_all(msg, 190, "!g", "^4")
	replace_all(msg, 190, "!y", "^1")
	replace_all(msg, 190, "!t", "^3")

	if (id) players[0] = id; else get_players(players, count, "ch") 
	{
		for ( new i = 0; i < count; i++ ){
			if ( g_isconnected[players[i]] ){
				message_begin(MSG_ONE_UNRELIABLE, g_msgSayText, _, players[i])
				write_byte(players[i]);
				write_string(msg);
				message_end();
			}
		}
	}
}

stock Float:fm_get_user_speed(id){
	if(!g_isconnected[id])
		return 0.0;
	
	static Float:fVelocity[3];
	pev(id, pev_velocity, fVelocity);
	fVelocity[2] = 0.0;
	return vector_length(fVelocity);
}

stock Float:is_user_outside(id){
	new Float:vOrigin[3], Float:fDist;
	pev(id, pev_origin, vOrigin);
	
	fDist = vOrigin[2];
	
	while(engfunc(EngFunc_PointContents, vOrigin) == CONTENTS_EMPTY)
		vOrigin[2] += 5.0;
	
	if(engfunc(EngFunc_PointContents, vOrigin) == CONTENTS_SKY)
		return (vOrigin[2] - fDist);
	
	return 0.0;
}

// Set the precached model index (updates hitboxes server side)
stock fm_cs_set_user_model_index(id, value){
	// Prevent server crash if entity's private data not initalized
	if (pev_valid(id) != PDATA_SAFE)
		return;
	
	set_pdata_int(id, OFFSET_MODELINDEX, value, OFFSET_LINUX);
}

// Get User Team
stock fm_cs_get_user_team(id){
	// Prevent server crash if entity's private data not initalized
	if (pev_valid(id) != PDATA_SAFE)
		return FM_CS_TEAM_UNASSIGNED;
	
	return get_pdata_int(id, OFFSET_CSTEAMS, OFFSET_LINUX);
}

// Force select team
stock force_team_join(id, menu_msgid, /* const */ team[] = "5", /* const */ class[] = "0") {
	static jointeam[] = "jointeam"
	if (class[0] == '0') {
		engclient_cmd(id, jointeam, team)
		return
	}

	static msg_block, joinclass[] = "joinclass"
	msg_block = get_msg_block(menu_msgid)
	set_msg_block(menu_msgid, BLOCK_SET)
	engclient_cmd(id, jointeam, team)
	engclient_cmd(id, joinclass, class)
	set_msg_block(menu_msgid, msg_block)
}

// Stock by (probably) Twilight Suzuka -counts number of chars in a string
stock str_count(const str[], searchchar){
	new count, i, len = strlen(str);	
	for (i = 0; i <= len; i++){
		if(str[i] == searchchar)
			count++;
	}
	
	return count;
}

// Collect random csdm spawn points
stock load_spawns(){
	// Check for CSDM spawns of the current map
	new cfgdir[32], mapname[32], filepath[100], linedata[64];
	get_configsdir(cfgdir, charsmax(cfgdir));
	get_mapname(mapname, charsmax(mapname));
	formatex(filepath, charsmax(filepath), "%s/csdm/%s.spawns.cfg", cfgdir, mapname);
	
	// Load CSDM spawns if present
	if (file_exists(filepath)){
		new csdmdata[10][6], file = fopen(filepath,"rt");
		
		while (file && !feof(file)){
			fgets(file, linedata, charsmax(linedata));
			
			// invalid spawn
			if(!linedata[0] || str_count(linedata,' ') < 2) continue;
			
			// get spawn point data
			parse(linedata,csdmdata[0],5,csdmdata[1],5,csdmdata[2],5,csdmdata[3],5,csdmdata[4],5,csdmdata[5],5,csdmdata[6],5,csdmdata[7],5,csdmdata[8],5,csdmdata[9],5);
			
			// origin
			g_spawns[g_spawnCount][0] = floatstr(csdmdata[0]);
			g_spawns[g_spawnCount][1] = floatstr(csdmdata[1]);
			g_spawns[g_spawnCount][2] = floatstr(csdmdata[2]);
			
			// increase spawn count
			g_spawnCount++;
			if (g_spawnCount >= sizeof g_spawns) break;
		}
		if (file) fclose(file);
	}else{
		// Collect regular spawns
		collect_spawns_ent("info_player_start");
		collect_spawns_ent("info_player_deathmatch");
	}
	
	// Collect regular spawns for non-random spawning unstuck
	collect_spawns_ent2("info_player_start");
	collect_spawns_ent2("info_player_deathmatch");
}

// Collect spawn points from entity origins
stock collect_spawns_ent(const classname[]){
	new ent = -1
	while ((ent = engfunc(EngFunc_FindEntityByString, ent, "classname", classname)) != 0)
	{
		// get origin
		new Float:originF[3]
		pev(ent, pev_origin, originF)
		g_spawns[g_spawnCount][0] = originF[0]
		g_spawns[g_spawnCount][1] = originF[1]
		g_spawns[g_spawnCount][2] = originF[2]
		
		// increase spawn count
		g_spawnCount++
		if (g_spawnCount >= sizeof g_spawns) break;
	}
}

// Collect spawn points from entity origins
stock collect_spawns_ent2(const classname[]){
	new ent = -1
	while ((ent = engfunc(EngFunc_FindEntityByString, ent, "classname", classname)) != 0)
	{
		// get origin
		new Float:originF[3]
		pev(ent, pev_origin, originF)
		g_spawns2[g_spawnCount2][0] = originF[0]
		g_spawns2[g_spawnCount2][1] = originF[1]
		g_spawns2[g_spawnCount2][2] = originF[2]
		
		// increase spawn count
		g_spawnCount2++
		if (g_spawnCount2 >= sizeof g_spawns2) break;
	}
}
/**************/
/* STOCKS END */
/**************/
